/*
Copyright Renaud GICQUEL 2005-2006 
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import extThopt.*;

public class DowThermA extends extThopt.ExtSubstance
{
    
    public DowThermA (){
        
        //donnes extraites de FLUIDFILE, logiciel de calcul de Dow Chemical
        super();
        type=getType();
        M=166; PC=31.34; TC=770.15; 
        Tmini=288.15;  Tmaxi=673.15; 
        chemForm="C12H10O (73.5% vol), C12H10 (26.5% vol)";  
    }
    
    public String getType(){
        return "Dowtherm A";
    }
	public String getClassDescription(){
	    return "data from FLUIDFILE software by Dow Chemical\n\nauthor : R. Gicquel   march 2006";
	}
    
	public double getT_from_hP(double $hv,double $P){
	    double a=0.00288257166597425,b=1.50760947237225;
    
 //       double a=0.00281914712153519,b=1.51937611940298;
	    double c=-$hv;
	    a=a/2.;
	    double delta=b*b-4.*a*c;
	    double TT = (-b+Math.pow(delta,0.5))/2./a;
	    
	    return TT+273.15;
	}
    
    
	public double calcH (double T, double P,double x) {
	    double a=0.00288257166597425,b=1.50760947237225;
//        double a=0.00281914712153519,b=1.51937611940298;

	    double TT=T-273.15;
	    return b*TT+a/2.*TT*TT;
	}
	public double calcS (double T, double P,double x) {
	    double a=0.00288257166597425,b=1.50760947237225;
//        double a=0.00281914712153519,b=1.51937611940298;
	    double TT=T-273.15;
	    b=b-273.15*a;
	    return b*Math.log(T/273.15)+a*TT;
	}
	public double calcCv (double T, double P,double x) {
	    double a=0.00288257166597425,b=1.50760947237225;
//        double a=0.00281914712153519,b=1.51937611940298;

	    double TT=T-273.15;
	    return (b+a*TT)*1000.;
	}
	public double calcCp (double T, double P,double x) {
	    return calcCv(T, P, x);
	}
	public double calcV (double T, double P,double x) {
        double c=-0.00076316337761882,a=-0.659441906630585,b=1070.80055083;
 //       double c=0.00359047619047613,a=-1.54561904761903,b=1099.0;

	    double TT=T-273.15;
	    return 1./(c*TT*TT+a*TT+b);
	}

    public double getLiquidViscosity(double T) {
 
        double c=0.00426254346872718,a=-2.48954143002475,b=362.115729616634;

 //      double c=0.0000105059523809523,a=-0.00417113095238093,b=0.4305;

	    double TT=T-273.15;
	    return c*TT*TT+a*TT+b;
    }
    public double getVaporViscosity(double T) {
        double c=0.00426254346872718,a=-2.48954143002475,b=362.115729616634;
  //      double c=0.0000105059523809523,a=-0.00417113095238093,b=0.4305;

	    double TT=T-273.15;
	    return c*TT*TT+a*TT+b;
    }

    public double getLiquidConductivity(double T) {
        double a=-0.000170473618612381,b=0.145127617366016;

    //    double a=-0.00012183368869936,b=0.143468656716418;

	    double TT=T-273.15;
	    return a*TT+b;
    }
    public double getVaporConductivity(double T) {
        double a=-0.000170473618612381,b=0.145127617366016;
 //       double a=-0.00012183368869936,b=0.143468656716418;

	    double TT=T-273.15;
	    return a*TT+b;
    }  

}